org.h2.expression.condition

## Class ConditionInQuery

- java.lang.Object
- - org.h2.expression.Expression
  - - org.h2.expression.condition.ConditionInQuery

All Implemented Interfaces:
  HasSQL, Typed

    public final class ConditionInQuery
    extends Expression

An IN() condition with a subquery, as in WHERE ID IN(SELECT ...)

### Field Summary

### Fields inherited from class org.h2.expression.Expression

`AUTO_PARENTHESES, MAP_IN_AGGREGATE, MAP_IN_WINDOW, MAP_INITIAL, WITH_PARENTHESES, WITHOUT_PARENTHESES`

### Fields inherited from interface org.h2.util.HasSQL

`ADD_PLAN_INFORMATION, DEFAULT_SQL_FLAGS, NO_CASTS, QUOTE_ONLY_WHEN_REQUIRED, REPLACE_LOBS_FOR_TRACE, TRACE_SQL_FLAGS`

### Constructor Summary

Constructors
Constructor and Description
`ConditionInQuery(Expression left, boolean not, boolean whenOperand, Query query, boolean all, int compareType)`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `createIndexConditions(SessionLocal session, TableFilter filter)` Create index conditions if possible and attach them to the table filter.
`int` `getCost()` Estimate the cost to process the expression.
`Expression` `getNotIfPossible(SessionLocal session)` If it is possible, return the negated expression.
`TypeInfo` `getType()` Returns the data type.
`java.lang.StringBuilder` `getUnenclosedSQL(java.lang.StringBuilder builder, int sqlFlags)` Get the SQL statement of this expression.
`Value` `getValue(SessionLocal session)` Return the resulting value for the current row.
`java.lang.StringBuilder` `getWhenSQL(java.lang.StringBuilder builder, int sqlFlags)` Appends the SQL statement of this when operand to the specified builder.
`boolean` `getWhenValue(SessionLocal session, Value left)` Return the resulting value of when operand for the current row.
`boolean` `isEverything(ExpressionVisitor visitor)` Check if this expression and all sub-expressions can fulfill a criteria.
`boolean` `isWhenConditionOperand()` Returns whether this expression is a right side of condition in a when operand.
`void` `mapColumns(ColumnResolver resolver, int level, int state)` Map the columns of the resolver to expression columns.
`boolean` `needParentheses()` Returns whether this expressions needs to be wrapped in parentheses when it is used as an argument of other expressions.
`Expression` `optimize(SessionLocal session)` Try to optimize the expression.
`void` `setEvaluatable(TableFilter tableFilter, boolean b)` Tell the expression columns whether the table filter can return values now.
`void` `updateAggregate(SessionLocal session, int stage)` Update an aggregate value.

### Methods inherited from class org.h2.expression.Expression

`addFilterConditions, getAlias, getBooleanValue, getColumnName, getColumnNameForView, getEnclosedSQL, getNonAliasExpression, getNullable, getSchemaName, getSQL, getSQL, getSQL, getSQL, getSubexpression, getSubexpressionCount, getTableAlias, getTableName, isConstant, isIdentity, isNullConstant, isValueSet, optimizeCondition, toString, writeExpressions, writeExpressions`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.h2.util.HasSQL

`getTraceSQL`

### Constructor Detail

#### ConditionInQuery

    public ConditionInQuery(Expression left,
                            boolean not,
                            boolean whenOperand,
                            Query query,
                            boolean all,
                            int compareType)

### Method Detail

#### getValue

    public Value getValue(SessionLocal session)

Description copied from class: `Expression`
Return the resulting value for the current row.

Specified by:
  `getValue` in class `Expression`
Parameters:
  `session` - the session
Returns:
  the result

#### getWhenValue

    public boolean getWhenValue(SessionLocal session,
                                Value left)

Description copied from class: `Expression`
Return the resulting value of when operand for the current row.

Overrides:
  `getWhenValue` in class `Expression`
Parameters:
  `session` - the session
  `left` - value on the left side
Returns:
  the result

#### isWhenConditionOperand

    public boolean isWhenConditionOperand()

Description copied from class: `Expression`
Returns whether this expression is a right side of condition in a when operand.

Overrides:
  `isWhenConditionOperand` in class `Expression`
Returns:
  `true` if it is, `false` otherwise

#### getNotIfPossible

    public Expression getNotIfPossible(SessionLocal session)

Description copied from class: `Expression`
If it is possible, return the negated expression. This is used to optimize NOT expressions: NOT ID>10 can be converted to ID<=10. Returns null if negating is not possible.

Overrides:
  `getNotIfPossible` in class `Expression`
Parameters:
  `session` - the session
Returns:
  the negated expression, or null

#### mapColumns

    public void mapColumns(ColumnResolver resolver,
                           int level,
                           int state)

Description copied from class: `Expression`
Map the columns of the resolver to expression columns.

Parameters:
  `resolver` - the column resolver
  `level` - the subquery nesting level
  `state` - current state for nesting checks, initial value is `Expression.MAP_INITIAL`

#### optimize

    public Expression optimize(SessionLocal session)

Description copied from class: `Expression`
Try to optimize the expression.

Parameters:
  `session` - the session
Returns:
  the optimized expression

#### setEvaluatable

    public void setEvaluatable(TableFilter tableFilter,
                               boolean b)

Description copied from class: `Expression`
Tell the expression columns whether the table filter can return values now. This is used when optimizing the query.

Parameters:
  `tableFilter` - the table filter
  `b` - true if the table filter can return value

#### needParentheses

    public boolean needParentheses()

Description copied from class: `Expression`
Returns whether this expressions needs to be wrapped in parentheses when it is used as an argument of other expressions.

Overrides:
  `needParentheses` in class `Expression`
Returns:
  `true` if it is

#### getUnenclosedSQL

    public java.lang.StringBuilder getUnenclosedSQL(java.lang.StringBuilder builder,
                                                    int sqlFlags)

Description copied from class: `Expression`
Get the SQL statement of this expression. This may not always be the original SQL statement, especially after optimization. Enclosing '(' and ')' are never appended.

Parameters:
  `builder` - string builder
  `sqlFlags` - formatting flags
Returns:
  the specified string builder

#### getWhenSQL

    public java.lang.StringBuilder getWhenSQL(java.lang.StringBuilder builder,
                                              int sqlFlags)

Description copied from class: `Expression`
Appends the SQL statement of this when operand to the specified builder.

Overrides:
  `getWhenSQL` in class `Expression`
Parameters:
  `builder` - string builder
  `sqlFlags` - formatting flags
Returns:
  the specified string builder

#### updateAggregate

    public void updateAggregate(SessionLocal session,
                                int stage)

Description copied from class: `Expression`
Update an aggregate value. This method is called at statement execution time. It is usually called once for each row, but if the expression is used multiple times (for example in the column list, and as part of the HAVING expression) it is called multiple times - the row counter needs to be used to make sure the internal state is only updated once.

Parameters:
  `session` - the session
  `stage` - select stage

#### isEverything

    public boolean isEverything(ExpressionVisitor visitor)

Description copied from class: `Expression`
Check if this expression and all sub-expressions can fulfill a criteria. If any part returns false, the result is false.

Parameters:
  `visitor` - the visitor
Returns:
  if the criteria can be fulfilled

#### getCost

    public int getCost()

Description copied from class: `Expression`
Estimate the cost to process the expression. Used when optimizing the query, to calculate the query plan with the lowest estimated cost.

Returns:
  the estimated cost

#### createIndexConditions

    public void createIndexConditions(SessionLocal session,
                                      TableFilter filter)

Description copied from class: `Expression`
Create index conditions if possible and attach them to the table filter.

Overrides:
  `createIndexConditions` in class `Expression`
Parameters:
  `session` - the session
  `filter` - the table filter

#### getType

    public TypeInfo getType()

Description copied from class: `Expression`
Returns the data type. The data type may be unknown before the optimization phase.

Specified by:
  `getType` in interface `Typed`
Specified by:
  `getType` in class `Expression`
Returns:
  the data type